#include <bits/stdc++.h>

using namespace std;

long long h, n, a;
long long kraj_kamenja=-1, pocetak_kamenja=-1, vrednost_kamenja=0;
int vrednost[1000002];

void stampaj()
{
    // cout << "==> ";

    for(int i=0; i < n-1; i++)
    {
        cout << vrednost[i] << " ";
    }
    cout << vrednost[n-1] << endl;

}

int main()
{
    cin >> h >> n;

    for(int i=0; i < n; i++)
    {
        vrednost[i] = 1;
    }


    for(int i=0; i < h; i++)
    {
        kraj_kamenja=-1;
        pocetak_kamenja=-1;
        vrednost_kamenja=0;

        for(int j=0; j < n; j++)
        {
            cin >> a;

            if(a == 0)
            {
                if(pocetak_kamenja  == -1)
                {
                    pocetak_kamenja = j;
                }
                kraj_kamenja = j;
                vrednost_kamenja += vrednost[j];
            }
            else
            {
                if(pocetak_kamenja  != -1)
                {
                    if(pocetak_kamenja == 0)
                    {
                        vrednost[kraj_kamenja+1] += vrednost_kamenja;
                    }
                    else if(kraj_kamenja == n-1)
                    {
                        vrednost[pocetak_kamenja-1] += vrednost_kamenja;
                    }
                    else
                    {
                        vrednost[pocetak_kamenja-1] += vrednost_kamenja/2;
                        vrednost[kraj_kamenja+1] += vrednost_kamenja/2;
                        if(vrednost_kamenja % 2 == 1)
                        {
                            //neparno
                            if(i % 2 == 0)
                            {
                                vrednost[pocetak_kamenja-1]++;
                            }
                            //parno
                            else
                            {
                                vrednost[kraj_kamenja+1]++;
                            }
                        }
                    }

                    if((j < n-1) || (kraj_kamenja != n-1))
                    {
                        for(int k = pocetak_kamenja; k <= kraj_kamenja; k++)
                        {
                            vrednost[k] = 0;
                        }
                        pocetak_kamenja = -1;
                        kraj_kamenja = -1;
                        vrednost_kamenja = 0;
                    }
                }
            }
        }

        if(kraj_kamenja == n-1)
        {
            vrednost[pocetak_kamenja-1] += vrednost_kamenja;
            for(int k = pocetak_kamenja; k <= kraj_kamenja; k++)
            {
                vrednost[k] = 0;
            }
        }

        //stampaj();
    }

    stampaj();

    return 0;
}